//==============================================================================
// Product name: DBMemBenchmark
// Copyright 2003 AidAim Software LLC.
//==============================================================================
unit MainUnit;

{DEFINE NO_PROGRESS}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DBClient, kbmMemTable, DB, Spin, SQLMemMain, Grids,
  DBISAMTb, FormProgress;

type
  TForm1 = class(TForm)
    kbmMemTable1: TkbmMemTable;
    CDSTable1: TClientDataSet;
    bnTestSQLMemTable: TButton;
    bnTestKBMMemTable: TButton;
    bnTestClientDataset: TButton;
    Label4: TLabel;
    seRecordCount: TSpinEdit;
    bnTestAll: TButton;
    Button5: TButton;
    SQLMemTable1: TSQLMemTable;
    DBISAMTable1: TDBISAMTable;
    GroupBox1: TGroupBox;
    sgResults: TStringGrid;
    bnTestDBISAM: TButton;
    procedure Button5Click(Sender: TObject);
    procedure bnTestSQLMemTableClick(Sender: TObject);
    procedure bnTestKBMMemTableClick(Sender: TObject);
    procedure bnTestClientDatasetClick(Sender: TObject);
    procedure bnTestAllClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bnTestDBISAMClick(Sender: TObject);
  private
    FTime:  Cardinal;
    FTime1: Cardinal;
  private
    { Private declarations }
    procedure ShowProgress(
                            Dataset:    TDataset;
                            Msg:        String;
                            TestNo:     Integer;
                            UseIndexes: Boolean
                         );
    procedure WriteToLog(
                            Dataset:    TDataset;
                            Msg:        String;
                            TestNo:     Integer;
                            Time:       Cardinal;
                            UseIndexes: Boolean
                         );
    procedure CreateTables(UseIndexes: Boolean);
    procedure InsertTest(Dataset: TDataset; UseIndexes: Boolean);
    procedure EditTest(Dataset: TDataset; UseIndexes: Boolean);
    procedure DeleteTest(Dataset: TDataset; UseIndexes: Boolean);
    procedure LocateByIDTest(Dataset: TDataset; UseIndexes: Boolean);
    procedure LocateByFIntegerTest(Dataset: TDataset; UseIndexes: Boolean);
    procedure LocateByFStringTest(Dataset: TDataset; UseIndexes: Boolean);

    procedure TestAll(Dataset: TDataset; UseIndexes: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const NO_TIME = $FFFFFFFF;

implementation

{$R *.dfm}

function GenerateString(
                       Len : Integer // serial length
                       ) : String; // returns serial
var i,x : integer;
    s : string;
    c : char;
begin
 s := '';

 for i := 1 to len do
  begin
   x := Random(101);
   if ((x mod 2) =  0) then
    c := chr(65+(Random(260000000) mod 26))
   else
    c := chr(48+(Random(100000000) mod 10));

   s := s + c;
  end; //len
 result := s;
end; // GenerateString


procedure TForm1.ShowProgress(
                            Dataset:    TDataset;
                            Msg:        String;
                            TestNo:     Integer;
                            UseIndexes: Boolean
                         );
var EngineName: String;
    f:          Double;
begin
{$IFDEF NO_PROGRESS}
Exit;
{$ENDIF}
   if (UseIndexes) then
    Msg := Msg + ' with indexes'
   else
    Msg := Msg + ' without indexes';
 if (Dataset = SQLMemTable1) then
  EngineName := sgResults.Cells[1,0];
 if (Dataset = kbmMemTable1) then
  EngineName := sgResults.Cells[2,0];
 if (Dataset = CDSTable1) then
  EngineName := sgResults.Cells[3,0];
 if (Dataset = DBISAMTable1) then
  EngineName := sgResults.Cells[4,0];
 if (UseIndexes) then
  TestNo := TestNo+6;
 f := TestNo-1;
 fmProgress.Init(Msg,EngineName,Round(f / 14.0 * 100.0));
end; // ShowProgress


procedure TForm1.WriteToLog(
                            Dataset:    TDataset;
                            Msg:        String;
                            TestNo:     Integer;
                            Time:       Cardinal;
                            UseIndexes: Boolean
                            );
var Column: Integer;
begin
   if (UseIndexes) then
    Msg := Msg + ' with indexes'
   else
    Msg := Msg + ' without indexes';
 if (Dataset = SQLMemTable1) then
  Column := 1;
 if (Dataset = kbmMemTable1) then
  Column := 2;
 if (Dataset = CDSTable1) then
  Column := 3;
 if (Dataset = DBISAMTable1) then
  Column := 4;
 if (UseIndexes) then
  Inc(TestNo,6);
 if (Time = NO_TIME) then
  begin
   sgResults.Cells[0,TestNo] := Msg + ' ...';
   sgResults.Cells[Column,TestNo] := '';
  end
 else
  begin
   sgResults.Cells[0,TestNo] := Msg;
   sgResults.Cells[Column,TestNo] := IntToStr(Time) + ' ms';
  end;
 Application.ProcessMessages;
end;

procedure TForm1.CreateTables(UseIndexes: Boolean);
begin
 SQLMemTable1.Close;
 if (SQLMemTable1.Exists) then
   SQLMemTable1.DeleteTable;
 SQLMemTable1.FieldDefs.Clear;
 SQLMemTable1.FieldDefs.Add('ID',ftAutoInc);
 SQLMemTable1.FieldDefs.Add('FString',ftString,100);
 SQLMemTable1.FieldDefs.Add('FInteger',ftInteger,0);
 SQLMemTable1.IndexDefs.Clear;
 if (UseIndexes) then
  begin
   SQLMemTable1.IndexDefs.Add('index1','ID',[]);
   SQLMemTable1.IndexDefs.Add('index2','FString',[]);
   SQLMemTable1.IndexDefs.Add('index3','FInteger',[]);
  end;
 SQLMemTable1.CreateTable;
 SQLMemTable1.Open;

 KBMMemTable1.Close;
 if (KBMMemTable1.Exists) then
   KBMMemTable1.DeleteTable;
 KBMMemTable1.FieldDefs.Clear;
 KBMMemTable1.FieldDefs.Add('ID',ftAutoInc);
 KBMMemTable1.FieldDefs.Add('FString',ftString,100);
 KBMMemTable1.FieldDefs.Add('FInteger',ftInteger,0);
 KBMMemTable1.IndexDefs.Clear;
 if (UseIndexes) then
  begin
   KBMMemTable1.IndexDefs.Add('index1','ID',[]);
   KBMMemTable1.IndexDefs.Add('index2','FString',[]);
   KBMMemTable1.IndexDefs.Add('index3','FInteger',[]);
  end;
 KBMMemTable1.CreateTable;
 KBMMemTable1.Open;

 CDSTable1.Close;
 CDSTable1.FieldDefs.Clear;
 CDSTable1.FieldDefs.Add('ID',ftAutoInc);
 CDSTable1.FieldDefs.Add('FString',ftString,100);
 CDSTable1.FieldDefs.Add('FInteger',ftInteger,0);
 CDSTable1.IndexDefs.Clear;
 if (UseIndexes) then
  begin
   CDSTable1.IndexDefs.Add('index1','ID',[]);
   CDSTable1.IndexDefs.Add('index2','FString',[]);
   CDSTable1.IndexDefs.Add('index3','FInteger',[]);
  end;
 CDSTable1.CreateDataSet;
 CDSTable1.Open;

 DBISAMTable1.Close;
 if (DBISAMTable1.Exists) then
   DBISAMTable1.DeleteTable;
 DBISAMTable1.FieldDefs.Clear;
 DBISAMTable1.FieldDefs.Add('ID',ftAutoInc);
 DBISAMTable1.FieldDefs.Add('FString',ftString,100);
 DBISAMTable1.FieldDefs.Add('FInteger',ftInteger,0);
 DBISAMTable1.IndexDefs.Clear;
 if (UseIndexes) then
  begin
   DBISAMTable1.IndexDefs.Add('index1','ID',[]);
   DBISAMTable1.IndexDefs.Add('index2','FString',[]);
   DBISAMTable1.IndexDefs.Add('index3','FInteger',[]);
  end;
 DBISAMTable1.CreateTable;
 DBISAMTable1.Open;
end; //


procedure TForm1.InsertTest(Dataset: TDataset; UseIndexes: Boolean);
var i,x,y: Integer;
    str:   String;
begin
 WriteToLog(Dataset,'Insert',1,NO_TIME,UseIndexes);
 ShowProgress(Dataset,'Insert',1,UseIndexes);
 y := seRecordCount.Value div 100;
 FTime := GetTickCount;
 for i := 1 to seRecordCount.Value do
  begin
   FTime1 := GetTickCount;
   x := random (MAXInt) mod (seRecordCount.Value div 10);
   str := GenerateString(100);
   FTime := FTime + (GetTickCount - FTime1);
   Dataset.Insert;
   Dataset.FieldByName('FInteger').AsInteger := x;
   Dataset.FieldByName('FString').AsString := str;
   Dataset.Post;
{$IFNDEF NO_PROGRESS}
   if ((i mod y) = 0) then
    begin
     fmProgress.gCurrent.Progress:= Round((i / seRecordCount.Value )* 100.0);
     Application.ProcessMessages;
     if (FormProgress.CloseFlag) then Exit;
    end;
{$ENDIF}
  end;
 FTime := GetTickCount - FTime;
 WriteToLog(Dataset,'Insert',1,FTime,UseIndexes);
end; //


procedure TForm1.EditTest(Dataset: TDataset; UseIndexes: Boolean);
var i,y,x:  Integer;
    str:    String;
begin
 WriteToLog(Dataset,'Edit',2,NO_TIME,UseIndexes);
 ShowProgress(Dataset,'Edit',2,UseIndexes);
 y := seRecordCount.Value div 100;
 FTime := GetTickCount;
 for i := 1 to seRecordCount.Value do
  begin
   Dataset.RecNo := i;
   FTime1 := GetTickCount;
   x := random (MAXInt) mod (seRecordCount.Value div 10);
   str := GenerateString(100);
   FTime := FTime + (GetTickCount - FTime1);
   Dataset.Edit;
   Dataset.FieldByName('FInteger').AsInteger := x;
   Dataset.FieldByName('FString').AsString := str;
   Dataset.Post;
{$IFNDEF NO_PROGRESS}
   if ((i mod y) = 0) then
    begin
     fmProgress.gCurrent.Progress:= Round((i / seRecordCount.Value )* 100.0);
     Application.ProcessMessages;
     if (FormProgress.CloseFlag) then Exit;
    end;
{$ENDIF}
  end;
 FTime := GetTickCount - FTime;
 WriteToLog(Dataset,'Edit',2,FTime,UseIndexes);
end; //


procedure TForm1.DeleteTest(Dataset: TDataset; UseIndexes: Boolean);
var RecCount: Double;
    i,y:      Integer;
begin
 WriteToLog(Dataset,'Delete',6,NO_TIME,UseIndexes);
 ShowProgress(Dataset,'Delete',6,UseIndexes);
 RecCount := dataset.RecordCount;
 i := 1;
 y := dataset.RecordCount div 100;
 FTime := GetTickCount;
 while (dataset.RecordCount > 0) do
  begin
   dataset.Delete;
   Inc(i);
{$IFNDEF NO_PROGRESS}
   if ((i mod y) = 0) then
    begin
     fmProgress.gCurrent.Progress:= Round(((RecCount - dataset.recordCount) / RecCount)* 100.0);
     Application.ProcessMessages;
     if (FormProgress.CloseFlag) then Exit;
    end; 
{$ENDIF}
  end;
 FTime := GetTickCount - FTime;
 WriteToLog(Dataset,'Delete',6,FTime,UseIndexes);
end; //


procedure TForm1.LocateByIDTest(Dataset: TDataset; UseIndexes: Boolean);
var i,x,y,OldRecNo: Integer;
begin
 WriteToLog(Dataset,'Locate By ID',3,NO_TIME,UseIndexes);
 ShowProgress(Dataset,'Locate By ID',3,UseIndexes);
 y := 10;
 FTime := GetTickCount;
 for i := 1 to 1000 do
  begin
   Dataset.RecNo := i;
   OldRecNo := Dataset.RecNo;
   x := Dataset.FieldByName('ID').AsInteger;
   Dataset.RecNo := 1;
   if (not Dataset.Locate('ID',x,[])) then
     raise Exception.Create('Locate By ID test failed');
   if (Dataset.FieldByName('ID').AsInteger <> x) then
     raise Exception.Create('Locate By ID test failed invalid record found');
{$IFNDEF NO_PROGRESS}
   if ((i mod y) = 0) then
    begin
     fmProgress.gCurrent.Progress:= Round((i / 1000 )* 100.0);
     Application.ProcessMessages;
     if (FormProgress.CloseFlag) then Exit;
    end; 
{$ENDIF}
  end;
 FTime := GetTickCount - FTime;
 WriteToLog(Dataset,'Locate By ID',3,FTime,UseIndexes);
end; //


procedure TForm1.LocateByFIntegerTest(Dataset: TDataset; UseIndexes: Boolean);
var i,x,y,OldRecNo: Integer;
begin
 WriteToLog(Dataset,'Locate By FInteger',4,NO_TIME,UseIndexes);
 ShowProgress(Dataset,'Locate By FInteger',4,UseIndexes);
 y := 10;
 FTime := GetTickCount;
 for i := 1 to 1000 do
  begin
   Dataset.RecNo := i;
   OldRecNo := Dataset.RecNo;
   x := Dataset.FieldByName('FInteger').AsInteger;
   Dataset.RecNo := 1;
   if (not Dataset.Locate('FInteger',x,[])) then
     raise Exception.Create('Locate By FInteger test failed');
   if (Dataset.FieldByName('FInteger').AsInteger <> x) then
     raise Exception.Create('Locate By FInteger test failed record found');
{$IFNDEF NO_PROGRESS}
   if ((i mod y) = 0) then
    begin
     fmProgress.gCurrent.Progress:= Round((i / 1000 )* 100.0);
     Application.ProcessMessages;
     if (FormProgress.CloseFlag) then Exit;
    end;
{$ENDIF}
  end;
 FTime := GetTickCount - FTime;
 WriteToLog(Dataset,'Locate By FInteger',4,FTime,UseIndexes);
end; //


procedure TForm1.LocateByFStringTest(Dataset: TDataset; UseIndexes: Boolean);
var i,x,y,OldRecNo: Integer;
    s: string;
begin
 WriteToLog(Dataset,'Locate By FString',5,NO_TIME,UseIndexes);
 ShowProgress(Dataset,'Locate By FString',5,UseIndexes);
 y := 10;
 FTime := GetTickCount;
 for i := 1 to 1000 do
  begin
   Dataset.RecNo := i;
   OldRecNo := Dataset.RecNo;
   s := Dataset.FieldByName('FString').AsString;
   Dataset.RecNo := 1;
   if (not Dataset.Locate('FString',s,[])) then
     raise Exception.Create('Locate By FString test failed');
   if (Dataset.FieldByName('FString').AsString <> s) then
     raise Exception.Create('Locate By FString test failed record found');
{$IFNDEF NO_PROGRESS}
   if ((i mod y) = 0) then
    begin
     fmProgress.gCurrent.Progress:= Round((i / 1000 )* 100.0);
     Application.ProcessMessages;
     if (FormProgress.CloseFlag) then Exit;
    end; 
{$ENDIF}
  end;
 FTime := GetTickCount - FTime;
 WriteToLog(Dataset,'Locate By FString',5,FTime,UseIndexes);
end; //


procedure TForm1.TestAll(Dataset: TDataset; UseIndexes: Boolean);
begin
 InsertTest(Dataset,UseIndexes);
 if (FormProgress.CloseFlag) then Exit;
 EditTest(Dataset,UseIndexes);
 if (FormProgress.CloseFlag) then Exit;
 LocateByIDTest(Dataset,UseIndexes);
 if (FormProgress.CloseFlag) then Exit;
 LocateByFIntegerTest(Dataset,UseIndexes);
 if (FormProgress.CloseFlag) then Exit;
 LocateByFStringTest(Dataset,UseIndexes);
 if (FormProgress.CloseFlag) then Exit;
 DeleteTest(Dataset,UseIndexes);
 if (FormProgress.CloseFlag) then Exit;
end; //


procedure TForm1.Button5Click(Sender: TObject);
begin
 Application.Terminate;
 Application.ProcessMessages;
 Close;
end;

procedure TForm1.bnTestSQLMemTableClick(Sender: TObject);
begin
 CreateTables(False);
 TestAll(SQLMemTable1,False);
 if (FormProgress.CloseFlag) then
  begin
   fmProgress.Hide;
   Exit;
  end;
 CreateTables(True);
 TestAll(SQLMemTable1,True);
 fmProgress.gOverall.Progress := 100;
 Application.ProcessMessages;
 fmProgress.Hide;
end;

procedure TForm1.bnTestKBMMemTableClick(Sender: TObject);
begin
 CreateTables(False);
 TestAll(KBMMemTable1,False);
 if (FormProgress.CloseFlag) then
  begin
   fmProgress.Hide;
   Exit;
  end;
 CreateTables(True);
 TestAll(KBMMemTable1,True);
 fmProgress.gOverall.Progress := 100;
 Application.ProcessMessages;
 fmProgress.Hide;
end;

procedure TForm1.bnTestClientDatasetClick(Sender: TObject);
begin
 CreateTables(False);
 TestAll(CDSTable1,False);
 if (FormProgress.CloseFlag) then
  begin
   fmProgress.Hide;
   Exit;
  end;
 CreateTables(True);
 TestAll(CDSTable1,True);
 fmProgress.gOverall.Progress := 100;
 Application.ProcessMessages;
 fmProgress.Hide;
end;

procedure TForm1.bnTestAllClick(Sender: TObject);
begin
 bnTestSQLMemTableClick(Sender);
 if (FormProgress.CloseFlag) then Exit;
 bnTestKBMMemTableClick(Sender);
 if (FormProgress.CloseFlag) then Exit;
 bnTestClientDatasetClick(Sender);
 if (FormProgress.CloseFlag) then Exit;
 bnTestDBISAMClick(Sender);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 sgResults.ColWidths[0] := 245;
 sgResults.Cells[0,0] := 'Test operation';
 sgResults.Cells[1,0] := 'SQLMemTable';
 sgResults.Cells[2,0] := 'KBMMemTable';
 sgResults.Cells[3,0] := 'ClientDataset';
 sgResults.Cells[4,0] := 'DBISAM Memory';
end;

procedure TForm1.bnTestDBISAMClick(Sender: TObject);
begin
 CreateTables(False);
 TestAll(DBISAMTable1,False);
 if (FormProgress.CloseFlag) then
  begin
   fmProgress.Hide;
   Exit;
  end;
 CreateTables(True);
 TestAll(DBISAMTable1,True);
 fmProgress.gOverall.Progress := 100;
 Application.ProcessMessages;
 fmProgress.Hide;
end;

initialization

 Randomize;

end.
